Merge branch 'sb/object-store'
[git] / git-rebase.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano.
4 #
5
6 SUBDIRECTORY_OK=Yes
7 OPTIONS_KEEPDASHDASH=
8 OPTIONS_STUCKLONG=t
9 OPTIONS_SPEC="\
10 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
11 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
12 git rebase --continue | --abort | --skip | --edit-todo
13 --
14  Available options are
15 v,verbose!         display a diffstat of what changed upstream
16 q,quiet!           be quiet. implies --no-stat
17 autostash          automatically stash/stash pop before and after
18 fork-point         use 'merge-base --fork-point' to refine upstream
19 onto=!             rebase onto given branch instead of upstream
20 p,preserve-merges! try to recreate merges instead of ignoring them
21 s,strategy=!       use the given merge strategy
22 no-ff!             cherry-pick all commits, even if unchanged
23 m,merge!           use merging strategies to rebase
24 i,interactive!     let the user edit the list of commits to rebase
25 x,exec=!           add exec lines after each commit of the editable list
26 k,keep-empty       preserve empty commits during rebase
27 allow-empty-message allow rebasing commits with empty messages
28 f,force-rebase!    force rebase even if branch is up to date
29 X,strategy-option=! pass the argument through to the merge strategy
30 stat!              display a diffstat of what changed upstream
31 n,no-stat!         do not show diffstat of what changed upstream
32 verify             allow pre-rebase hook to run
33 rerere-autoupdate  allow rerere to update index with resolved conflicts
34 root!              rebase all reachable commits up to the root(s)
35 autosquash         move commits that begin with squash!/fixup! under -i
36 committer-date-is-author-date! passed to 'git am'
37 ignore-date!       passed to 'git am'
38 signoff            passed to 'git am'
39 whitespace=!       passed to 'git apply'
40 ignore-whitespace! passed to 'git apply'
41 C=!                passed to 'git apply'
42 S,gpg-sign?        GPG-sign commits
43  Actions:
44 continue!          continue
45 abort!             abort and check out the original branch
46 skip!              skip current patch and continue
47 edit-todo!         edit the todo list during an interactive rebase
48 quit!              abort but keep HEAD where it is
49 show-current-patch! show the patch file being applied or merged
50 "
51 . git-sh-setup
52 set_reflog_action rebase
53 require_work_tree_exists
54 cd_to_toplevel
55
56 LF='
57 '
58 ok_to_skip_pre_rebase=
59 resolvemsg="
60 $(gettext 'Resolve all conflicts manually, mark them as resolved with
61 "git add/rm <conflicted_files>", then run "git rebase --continue".
62 You can instead skip this commit: run "git rebase --skip".
63 To abort and get back to the state before "git rebase", run "git rebase --abort".')
64 "
65 unset onto
66 unset restrict_revision
67 cmd=
68 strategy=
69 strategy_opts=
70 do_merge=
71 merge_dir="$GIT_DIR"/rebase-merge
72 apply_dir="$GIT_DIR"/rebase-apply
73 verbose=
74 diffstat=
75 test "$(git config --bool rebase.stat)" = true && diffstat=t
76 autostash="$(git config --bool rebase.autostash || echo false)"
77 fork_point=auto
78 git_am_opt=
79 git_format_patch_opt=
80 rebase_root=
81 force_rebase=
82 allow_rerere_autoupdate=
83 # Non-empty if a rebase was in progress when 'git rebase' was invoked
84 in_progress=
85 # One of {am, merge, interactive}
86 type=
87 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
88 state_dir=
89 # One of {'', continue, skip, abort}, as parsed from command line
90 action=
91 preserve_merges=
92 autosquash=
93 keep_empty=
94 allow_empty_message=
95 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
96 case "$(git config --bool commit.gpgsign)" in
97 true)   gpg_sign_opt=-S ;;
98 *)      gpg_sign_opt= ;;
99 esac
100
101 read_basic_state () {
102         test -f "$state_dir/head-name" &&
103         test -f "$state_dir/onto" &&
104         head_name=$(cat "$state_dir"/head-name) &&
105         onto=$(cat "$state_dir"/onto) &&
106         # We always write to orig-head, but interactive rebase used to write to
107         # head. Fall back to reading from head to cover for the case that the
108         # user upgraded git with an ongoing interactive rebase.
109         if test -f "$state_dir"/orig-head
110         then
111                 orig_head=$(cat "$state_dir"/orig-head)
112         else
113                 orig_head=$(cat "$state_dir"/head)
114         fi &&
115         GIT_QUIET=$(cat "$state_dir"/quiet) &&
116         test -f "$state_dir"/verbose && verbose=t
117         test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
118         test -f "$state_dir"/strategy_opts &&
119                 strategy_opts="$(cat "$state_dir"/strategy_opts)"
120         test -f "$state_dir"/allow_rerere_autoupdate &&
121                 allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
122         test -f "$state_dir"/gpg_sign_opt &&
123                 gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
124 }
125
126 write_basic_state () {
127         echo "$head_name" > "$state_dir"/head-name &&
128         echo "$onto" > "$state_dir"/onto &&
129         echo "$orig_head" > "$state_dir"/orig-head &&
130         echo "$GIT_QUIET" > "$state_dir"/quiet &&
131         test t = "$verbose" && : > "$state_dir"/verbose
132         test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
133         test -n "$strategy_opts" && echo "$strategy_opts" > \
134                 "$state_dir"/strategy_opts
135         test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
136                 "$state_dir"/allow_rerere_autoupdate
137         test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
138 }
139
140 output () {
141         case "$verbose" in
142         '')
143                 output=$("$@" 2>&1 )
144                 status=$?
145                 test $status != 0 && printf "%s\n" "$output"
146                 return $status
147                 ;;
148         *)
149                 "$@"
150                 ;;
151         esac
152 }
153
154 move_to_original_branch () {
155         case "$head_name" in
156         refs/*)
157                 message="rebase finished: $head_name onto $onto"
158                 git update-ref -m "$message" \
159                         $head_name $(git rev-parse HEAD) $orig_head &&
160                 git symbolic-ref \
161                         -m "rebase finished: returning to $head_name" \
162                         HEAD $head_name ||
163                 die "$(eval_gettext "Could not move back to \$head_name")"
164                 ;;
165         esac
166 }
167
168 apply_autostash () {
169         if test -f "$state_dir/autostash"
170         then
171                 stash_sha1=$(cat "$state_dir/autostash")
172                 if git stash apply $stash_sha1 >/dev/null 2>&1
173                 then
174                         echo "$(gettext 'Applied autostash.')" >&2
175                 else
176                         git stash store -m "autostash" -q $stash_sha1 ||
177                         die "$(eval_gettext "Cannot store \$stash_sha1")"
178                         gettext 'Applying autostash resulted in conflicts.
179 Your changes are safe in the stash.
180 You can run "git stash pop" or "git stash drop" at any time.
181 ' >&2
182                 fi
183         fi
184 }
185
186 finish_rebase () {
187         rm -f "$(git rev-parse --git-path REBASE_HEAD)"
188         apply_autostash &&
189         { git gc --auto || true; } &&
190         rm -rf "$state_dir"
191 }
192
193 run_specific_rebase () {
194         if [ "$interactive_rebase" = implied ]; then
195                 GIT_EDITOR=:
196                 export GIT_EDITOR
197                 autosquash=
198         fi
199         . git-rebase--$type
200         git_rebase__$type${preserve_merges:+__preserve_merges}
201         ret=$?
202         if test $ret -eq 0
203         then
204                 finish_rebase
205         elif test $ret -eq 2 # special exit status for rebase -i
206         then
207                 apply_autostash &&
208                 rm -rf "$state_dir" &&
209                 die "Nothing to do"
210         fi
211         exit $ret
212 }
213
214 run_pre_rebase_hook () {
215         if test -z "$ok_to_skip_pre_rebase" &&
216            test -x "$(git rev-parse --git-path hooks/pre-rebase)"
217         then
218                 "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
219                 die "$(gettext "The pre-rebase hook refused to rebase.")"
220         fi
221 }
222
223 test -f "$apply_dir"/applying &&
224         die "$(gettext "It looks like 'git am' is in progress. Cannot rebase.")"
225
226 if test -d "$apply_dir"
227 then
228         type=am
229         state_dir="$apply_dir"
230 elif test -d "$merge_dir"
231 then
232         if test -f "$merge_dir"/interactive
233         then
234                 type=interactive
235                 interactive_rebase=explicit
236         else
237                 type=merge
238         fi
239         state_dir="$merge_dir"
240 fi
241 test -n "$type" && in_progress=t
242
243 total_argc=$#
244 while test $# != 0
245 do
246         case "$1" in
247         --no-verify)
248                 ok_to_skip_pre_rebase=yes
249                 ;;
250         --verify)
251                 ok_to_skip_pre_rebase=
252                 ;;
253         --continue|--skip|--abort|--quit|--edit-todo|--show-current-patch)
254                 test $total_argc -eq 2 || usage
255                 action=${1##--}
256                 ;;
257         --onto=*)
258                 onto="${1#--onto=}"
259                 ;;
260         --exec=*)
261                 cmd="${cmd}exec ${1#--exec=}${LF}"
262                 test -z "$interactive_rebase" && interactive_rebase=implied
263                 ;;
264         --interactive)
265                 interactive_rebase=explicit
266                 ;;
267         --keep-empty)
268                 keep_empty=yes
269                 ;;
270         --allow-empty-message)
271                 allow_empty_message=--allow-empty-message
272                 ;;
273         --preserve-merges)
274                 preserve_merges=t
275                 test -z "$interactive_rebase" && interactive_rebase=implied
276                 ;;
277         --autosquash)
278                 autosquash=t
279                 ;;
280         --no-autosquash)
281                 autosquash=
282                 ;;
283         --fork-point)
284                 fork_point=t
285                 ;;
286         --no-fork-point)
287                 fork_point=
288                 ;;
289         --merge)
290                 do_merge=t
291                 ;;
292         --strategy-option=*)
293                 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
294                 do_merge=t
295                 test -z "$strategy" && strategy=recursive
296                 ;;
297         --strategy=*)
298                 strategy="${1#--strategy=}"
299                 do_merge=t
300                 ;;
301         --no-stat)
302                 diffstat=
303                 ;;
304         --stat)
305                 diffstat=t
306                 ;;
307         --autostash)
308                 autostash=true
309                 ;;
310         --no-autostash)
311                 autostash=false
312                 ;;
313         --verbose)
314                 verbose=t
315                 diffstat=t
316                 GIT_QUIET=
317                 ;;
318         --quiet)
319                 GIT_QUIET=t
320                 git_am_opt="$git_am_opt -q"
321                 verbose=
322                 diffstat=
323                 ;;
324         --whitespace=*)
325                 git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
326                 case "${1#--whitespace=}" in
327                 fix|strip)
328                         force_rebase=t
329                         ;;
330                 esac
331                 ;;
332         --ignore-whitespace)
333                 git_am_opt="$git_am_opt $1"
334                 ;;
335         --committer-date-is-author-date|--ignore-date|--signoff|--no-signoff)
336                 git_am_opt="$git_am_opt $1"
337                 force_rebase=t
338                 ;;
339         -C*)
340                 git_am_opt="$git_am_opt $1"
341                 ;;
342         --root)
343                 rebase_root=t
344                 ;;
345         --force-rebase|--no-ff)
346                 force_rebase=t
347                 ;;
348         --rerere-autoupdate|--no-rerere-autoupdate)
349                 allow_rerere_autoupdate="$1"
350                 ;;
351         --gpg-sign)
352                 gpg_sign_opt=-S
353                 ;;
354         --gpg-sign=*)
355                 gpg_sign_opt="-S${1#--gpg-sign=}"
356                 ;;
357         --)
358                 shift
359                 break
360                 ;;
361         *)
362                 usage
363                 ;;
364         esac
365         shift
366 done
367 test $# -gt 2 && usage
368
369 if test -n "$action"
370 then
371         test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
372         # Only interactive rebase uses detailed reflog messages
373         if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
374         then
375                 GIT_REFLOG_ACTION="rebase -i ($action)"
376                 export GIT_REFLOG_ACTION
377         fi
378 fi
379
380 if test "$action" = "edit-todo" && test "$type" != "interactive"
381 then
382         die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
383 fi
384
385 case "$action" in
386 continue)
387         # Sanity check
388         git rev-parse --verify HEAD >/dev/null ||
389                 die "$(gettext "Cannot read HEAD")"
390         git update-index --ignore-submodules --refresh &&
391         git diff-files --quiet --ignore-submodules || {
392                 echo "$(gettext "You must edit all merge conflicts and then
393 mark them as resolved using git add")"
394                 exit 1
395         }
396         read_basic_state
397         run_specific_rebase
398         ;;
399 skip)
400         output git reset --hard HEAD || exit $?
401         read_basic_state
402         run_specific_rebase
403         ;;
404 abort)
405         git rerere clear
406         read_basic_state
407         case "$head_name" in
408         refs/*)
409                 git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
410                 die "$(eval_gettext "Could not move back to \$head_name")"
411                 ;;
412         esac
413         output git reset --hard $orig_head
414         finish_rebase
415         exit
416         ;;
417 quit)
418         exec rm -rf "$state_dir"
419         ;;
420 edit-todo)
421         run_specific_rebase
422         ;;
423 show-current-patch)
424         run_specific_rebase
425         die "BUG: run_specific_rebase is not supposed to return here"
426         ;;
427 esac
428
429 # Make sure no rebase is in progress
430 if test -n "$in_progress"
431 then
432         state_dir_base=${state_dir##*/}
433         cmd_live_rebase="git rebase (--continue | --abort | --skip)"
434         cmd_clear_stale_rebase="rm -fr \"$state_dir\""
435         die "
436 $(eval_gettext 'It seems that there is already a $state_dir_base directory, and
437 I wonder if you are in the middle of another rebase.  If that is the
438 case, please try
439         $cmd_live_rebase
440 If that is not the case, please
441         $cmd_clear_stale_rebase
442 and run me again.  I am stopping in case you still have something
443 valuable there.')"
444 fi
445
446 if test -n "$rebase_root" && test -z "$onto"
447 then
448         test -z "$interactive_rebase" && interactive_rebase=implied
449 fi
450
451 if test -n "$interactive_rebase"
452 then
453         type=interactive
454         state_dir="$merge_dir"
455 elif test -n "$do_merge"
456 then
457         type=merge
458         state_dir="$merge_dir"
459 else
460         type=am
461         state_dir="$apply_dir"
462 fi
463
464 if test -t 2 && test -z "$GIT_QUIET"
465 then
466         git_format_patch_opt="$git_format_patch_opt --progress"
467 fi
468
469 if test -z "$rebase_root"
470 then
471         case "$#" in
472         0)
473                 if ! upstream_name=$(git rev-parse --symbolic-full-name \
474                         --verify -q @{upstream} 2>/dev/null)
475                 then
476                         . git-parse-remote
477                         error_on_missing_default_upstream "rebase" "rebase" \
478                                 "against" "git rebase $(gettext '<branch>')"
479                 fi
480
481                 test "$fork_point" = auto && fork_point=t
482                 ;;
483         *)      upstream_name="$1"
484                 if test "$upstream_name" = "-"
485                 then
486                         upstream_name="@{-1}"
487                 fi
488                 shift
489                 ;;
490         esac
491         upstream=$(peel_committish "${upstream_name}") ||
492         die "$(eval_gettext "invalid upstream '\$upstream_name'")"
493         upstream_arg="$upstream_name"
494 else
495         if test -z "$onto"
496         then
497                 empty_tree=$(git hash-object -t tree /dev/null)
498                 onto=$(git commit-tree $empty_tree </dev/null)
499                 squash_onto="$onto"
500         fi
501         unset upstream_name
502         unset upstream
503         test $# -gt 1 && usage
504         upstream_arg=--root
505 fi
506
507 # Make sure the branch to rebase onto is valid.
508 onto_name=${onto-"$upstream_name"}
509 case "$onto_name" in
510 *...*)
511         if      left=${onto_name%...*} right=${onto_name#*...} &&
512                 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
513         then
514                 case "$onto" in
515                 ?*"$LF"?*)
516                         die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
517                         ;;
518                 '')
519                         die "$(eval_gettext "\$onto_name: there is no merge base")"
520                         ;;
521                 esac
522         else
523                 die "$(eval_gettext "\$onto_name: there is no merge base")"
524         fi
525         ;;
526 *)
527         onto=$(peel_committish "$onto_name") ||
528         die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
529         ;;
530 esac
531
532 # If the branch to rebase is given, that is the branch we will rebase
533 # $branch_name -- branch/commit being rebased, or HEAD (already detached)
534 # $orig_head -- commit object name of tip of the branch before rebasing
535 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
536 switch_to=
537 case "$#" in
538 1)
539         # Is it "rebase other $branchname" or "rebase other $commit"?
540         branch_name="$1"
541         switch_to="$1"
542
543         # Is it a local branch?
544         if git show-ref --verify --quiet -- "refs/heads/$branch_name" &&
545            orig_head=$(git rev-parse -q --verify "refs/heads/$branch_name")
546         then
547                 head_name="refs/heads/$branch_name"
548         # If not is it a valid ref (branch or commit)?
549         elif orig_head=$(git rev-parse -q --verify "$branch_name")
550         then
551                 head_name="detached HEAD"
552
553         else
554                 die "$(eval_gettext "fatal: no such branch/commit '\$branch_name'")"
555         fi
556         ;;
557 0)
558         # Do not need to switch branches, we are already on it.
559         if branch_name=$(git symbolic-ref -q HEAD)
560         then
561                 head_name=$branch_name
562                 branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
563         else
564                 head_name="detached HEAD"
565                 branch_name=HEAD
566         fi
567         orig_head=$(git rev-parse --verify HEAD) || exit
568         ;;
569 *)
570         die "BUG: unexpected number of arguments left to parse"
571         ;;
572 esac
573
574 if test "$fork_point" = t
575 then
576         new_upstream=$(git merge-base --fork-point "$upstream_name" \
577                         "${switch_to:-HEAD}")
578         if test -n "$new_upstream"
579         then
580                 restrict_revision=$new_upstream
581         fi
582 fi
583
584 if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
585 then
586         stash_sha1=$(git stash create "autostash") ||
587         die "$(gettext 'Cannot autostash')"
588
589         mkdir -p "$state_dir" &&
590         echo $stash_sha1 >"$state_dir/autostash" &&
591         stash_abbrev=$(git rev-parse --short $stash_sha1) &&
592         echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
593         git reset --hard
594 fi
595
596 require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
597
598 # Now we are rebasing commits $upstream..$orig_head (or with --root,
599 # everything leading up to $orig_head) on top of $onto
600
601 # Check if we are already based on $onto with linear history,
602 # but this should be done only when upstream and onto are the same
603 # and if this is not an interactive rebase.
604 mb=$(git merge-base "$onto" "$orig_head")
605 if test "$type" != interactive && test "$upstream" = "$onto" &&
606         test "$mb" = "$onto" && test -z "$restrict_revision" &&
607         # linear history?
608         ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
609 then
610         if test -z "$force_rebase"
611         then
612                 # Lazily switch to the target branch if needed...
613                 test -z "$switch_to" ||
614                 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
615                         git checkout -q "$switch_to" --
616                 if test "$branch_name" = "HEAD" &&
617                          ! git symbolic-ref -q HEAD
618                 then
619                         say "$(eval_gettext "HEAD is up to date.")"
620                 else
621                         say "$(eval_gettext "Current branch \$branch_name is up to date.")"
622                 fi
623                 finish_rebase
624                 exit 0
625         else
626                 if test "$branch_name" = "HEAD" &&
627                          ! git symbolic-ref -q HEAD
628                 then
629                         say "$(eval_gettext "HEAD is up to date, rebase forced.")"
630                 else
631                         say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
632                 fi
633         fi
634 fi
635
636 # If a hook exists, give it a chance to interrupt
637 run_pre_rebase_hook "$upstream_arg" "$@"
638
639 if test -n "$diffstat"
640 then
641         if test -n "$verbose"
642         then
643                 echo "$(eval_gettext "Changes from \$mb to \$onto:")"
644         fi
645         # We want color (if set), but no pager
646         GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
647 fi
648
649 test "$type" = interactive && run_specific_rebase
650
651 # Detach HEAD and reset the tree
652 say "$(gettext "First, rewinding head to replay your work on top of it...")"
653
654 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
655         git checkout -q "$onto^0" || die "could not detach HEAD"
656 git update-ref ORIG_HEAD $orig_head
657
658 # If the $onto is a proper descendant of the tip of the branch, then
659 # we just fast-forwarded.
660 if test "$mb" = "$orig_head"
661 then
662         say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
663         move_to_original_branch
664         finish_rebase
665         exit 0
666 fi
667
668 if test -n "$rebase_root"
669 then
670         revisions="$onto..$orig_head"
671 else
672         revisions="${restrict_revision-$upstream}..$orig_head"
673 fi
674
675 run_specific_rebase